# This files contains your custom actions which can be used to run
# custom Python code.
#
# See this guide on how to implement these action:
# https://rasa.com/docs/rasa/core/actions/#custom-actions/


# This is a simple example for a custom action which utters "Hello World!"

# from typing import Any, Text, Dict, List
#
# from rasa_sdk import Action, Tracker
# from rasa_sdk.executor import CollectingDispatcher
#
#
# class ActionHelloWorld(Action):
#
#     def name(self) -> Text:
#         return "action_hello_world"
#
#     def run(self, dispatcher: CollectingDispatcher,
#             tracker: Tracker,
#             domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
#
#         dispatcher.utter_message("Hello World!")
#
#         return []
from typing import Dict, Text, Any, List, Union, Optional

from rasa_sdk import ActionExecutionRejection
from rasa_sdk import Action
from rasa_sdk import Tracker
from rasa_sdk.events import SlotSet
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.forms import FormAction, REQUESTED_SLOT
import requests

		
price_db={"medium":["medium","moderate","moderately","mid","in range of 300 to 700","300 to 700","300-700","rs. 300 to 700","rs.300 to 700"],}
 
def price_validate(value:Text):
	for input in price_db:
		if value.lower() in price_db[input]:
			return input
	return None
 
cuisine_db={"chinese":["chinese","chines","chinese","chines"],"mexican":["mexican","mexica","taco","mex","spanish","mexicn","mexican","mxican","mexican"],"italian":["italian","italian","italic","italia","italin","itlian"],"north indian":["north indian","north indian","northindian","northindian","north indian","north indian","north indian","north food","northie","punjabi","punjab","gujarati","gujarat","bengali","bengal","kashmiri","kashmir"],"american":["american","american","america","americn","amrican"],"south indian":["south indian","south indian","indian","india","southindian","southindian","south food","southie","andhra","telugu","kerala","karnataka","tamil","south indian","south indian","south indian"],}
 
def cuisine_validate(value:Text):
	for input in cuisine_db:
		if value.lower() in cuisine_db[input]:
			return input
	return None
 
location_db={"ahmedabad":["ahmedabad","amdavad","ahmadabad","ahmedabad","ahmedbad","ahmeadbad","ahmedabad"],"bangalore":["bangalore","bengaluru","bengaluru","bangalore","blore","blr","bangalur"],"gurgaon":["gurgaon","gurugram","gurgao","gurugaon","gurugaon"],"chandigarh":["chandigarh","chandigarh","chandigadh","chandigar"],"lucknow":["lucknow","lucknow","lko","luknow"],"mumbai":["mumbai","bombay","mumbai","bombai","bombay"],"hyderabad":["hyderabad","secunderabad","hydrabad","hyderabad","hyderbad","hyderabd"],"new delhi":["new delhi","new delhi","delhi","delhi","delli","dilli","newdelhi"],"aligarh":["aligarh","aligarh","allygurh & koil","koil","allygurh","algarh","alligarh","aligarh","aligadh"],"agra":["agra","agra"],"pune":["pune","poona","pne","puna","puna","pune"],"prayagraj":["prayagraj","allahabad","illahabad","prayag"],}
 
def location_validate(value:Text):
	for input in location_db:
		if value.lower() in location_db[input]:
			return input
	return None
 
budget_min_db={"700":["700","70"],}
 
def budget_min_validate(value:Text):
	for input in budget_min_db:
		if value.lower() in budget_min_db[input]:
			return input
	return None
 
people_db={"4":["4","four"],}
 
def people_validate(value:Text):
	for input in people_db:
		if value.lower() in people_db[input]:
			return input
	return None
 
budget_max_db={"700":["700","70"],}
 
def budget_max_validate(value:Text):
	for input in budget_max_db:
		if value.lower() in budget_max_db[input]:
			return input
	return None
 
class restaurant_searchForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "restaurant_search_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["restaurant_search_location","restaurant_search_cuisine","restaurant_search_budget_max","restaurant_search_budget_min","restaurant_search_price","restaurant_search_people","restaurant_search_email_id","restaurant_search_budget_min"]
	def validate_restaurant_search_location(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = location_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_location', tracker)
			return {'restaurant_search_location': None}
		return {'restaurant_search_location': parseValue}
	def validate_restaurant_search_cuisine(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = cuisine_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_cuisine', tracker)
			return {'restaurant_search_cuisine': None}
		return {'restaurant_search_cuisine': parseValue}
	def validate_restaurant_search_budget_max(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = budget_max_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_budget_max', tracker)
			return {'restaurant_search_budget_max': None}
		return {'restaurant_search_budget_max': parseValue}
	def validate_restaurant_search_budget_min(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = budget_min_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_budget_min', tracker)
			return {'restaurant_search_budget_min': None}
		return {'restaurant_search_budget_min': parseValue}
	def validate_restaurant_search_price(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = price_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_price', tracker)
			return {'restaurant_search_price': None}
		return {'restaurant_search_price': parseValue}
	def validate_restaurant_search_people(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = people_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_people', tracker)
			return {'restaurant_search_people': None}
		return {'restaurant_search_people': parseValue}
	def validate_restaurant_search_email_id(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_email_id', tracker)
			return {'restaurant_search_email_id': None}
		return {'restaurant_search_email_id': parseValue}
	def validate_restaurant_search_budget_min(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		try:
			parseValue = int (value)
		except ValueError:
			parseValue = None
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_budget_min', tracker)
			return {'restaurant_search_budget_min': None}
		return {'restaurant_search_budget_min': parseValue}
	
	def slot_mappings(self):
	
		return {
		"restaurant_search_location": [self.from_entity(entity="restaurant_search_location"),self.from_text()],
		"restaurant_search_cuisine": [self.from_entity(entity="restaurant_search_cuisine"),self.from_text()],
		"restaurant_search_budget_max": [self.from_entity(entity="restaurant_search_budget_max"),self.from_text()],
		"restaurant_search_budget_min": [self.from_entity(entity="restaurant_search_budget_min"),self.from_text()],
		"restaurant_search_price": [self.from_entity(entity="restaurant_search_price"),self.from_text()],
		"restaurant_search_people": [self.from_entity(entity="restaurant_search_people"),self.from_text()],
		"restaurant_search_email_id": [self.from_entity(entity="restaurant_search_email_id"),self.from_text()],
		"restaurant_search_budget_min": [self.from_entity(entity="restaurant_search_budget_min"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class restaurant_searchClean (Action):
	def name(self) -> Text:
		return "restaurant_search_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("restaurant_search_location", None) ,SlotSet("restaurant_search_cuisine", None) ,SlotSet("restaurant_search_budget_max", None) ,SlotSet("restaurant_search_budget_min", None) ,SlotSet("restaurant_search_price", None) ,SlotSet("restaurant_search_people", None) ,SlotSet("restaurant_search_email_id", None) ,SlotSet("restaurant_search_budget_min", None) ]            
class send_mailForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "send_mail_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["send_mail_email_id"]
	def validate_send_mail_email_id(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_email_id', tracker)
			return {'send_mail_email_id': None}
		return {'send_mail_email_id': parseValue}
	
	def slot_mappings(self):
	
		return {
		"send_mail_email_id": [self.from_entity(entity="send_mail_email_id"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class send_mailClean (Action):
	def name(self) -> Text:
		return "send_mail_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("send_mail_email_id", None) ]            
class action_chk_location_empty (Action):
	def name(self) -> Text:
		return "action_chk_location_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
class action_verify_cuisine_empty (Action):
	def name(self) -> Text:
		return "action_verify_cuisine_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
	
	
	
class action_send_email_empty (Action):
	def name(self) -> Text:
		return "action_send_email_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
class action_search_restaurants_empty (Action):
	def name(self) -> Text:
		return "action_search_restaurants_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
class DefaultEmptyAction (Action):
	def name(self) -> Text:
		return "action_DefaultEmptyAction"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
