# This files contains your custom actions which can be used to run
# custom Python code.
#
# See this guide on how to implement these action:
# https://rasa.com/docs/rasa/core/actions/#custom-actions/


# This is a simple example for a custom action which utters "Hello World!"

# from typing import Any, Text, Dict, List
#
# from rasa_sdk import Action, Tracker
# from rasa_sdk.executor import CollectingDispatcher
#
#
# class ActionHelloWorld(Action):
#
#     def name(self) -> Text:
#         return "action_hello_world"
#
#     def run(self, dispatcher: CollectingDispatcher,
#             tracker: Tracker,
#             domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
#
#         dispatcher.utter_message("Hello World!")
#
#         return []
from typing import Dict, Text, Any, List, Union, Optional

from rasa_sdk import ActionExecutionRejection
from rasa_sdk import Action
from rasa_sdk import Tracker
from rasa_sdk.events import SlotSet
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.forms import FormAction, REQUESTED_SLOT
import requests

		
class affirmForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "affirm_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["affirm_age","affirm_city"]
	def validate_affirm_age(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_age', tracker)
			return {'affirm_age': None}
		return {'affirm_age': parseValue}
	def validate_affirm_city(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_city', tracker)
			return {'affirm_city': None}
		return {'affirm_city': parseValue}
	
	def slot_mappings(self):
	
		return {
		"affirm_age": [self.from_entity(entity="affirm_age"),self.from_text()],
		"affirm_city": [self.from_entity(entity="affirm_city"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class affirmClean (Action):
	def name(self) -> Text:
		return "affirm_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("affirm_age", None) ,SlotSet("affirm_city", None) ]            
class informForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "inform_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["inform_age","inform_city"]
	def validate_inform_age(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_age', tracker)
			return {'inform_age': None}
		return {'inform_age': parseValue}
	def validate_inform_city(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_city', tracker)
			return {'inform_city': None}
		return {'inform_city': parseValue}
	
	def slot_mappings(self):
	
		return {
		"inform_age": [self.from_entity(entity="inform_age"),self.from_text()],
		"inform_city": [self.from_entity(entity="inform_city"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class informClean (Action):
	def name(self) -> Text:
		return "inform_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("inform_age", None) ,SlotSet("inform_city", None) ]            
class action_weather_api_empty (Action):
	def name(self) -> Text:
		return "action_weather_api_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
class user_form_empty (Action):
	def name(self) -> Text:
		return "action_user_form_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
