# This files contains your custom actions which can be used to run
# custom Python code.
#
# See this guide on how to implement these action:
# https://rasa.com/docs/rasa/core/actions/#custom-actions/


# This is a simple example for a custom action which utters "Hello World!"

# from typing import Any, Text, Dict, List
#
# from rasa_sdk import Action, Tracker
# from rasa_sdk.executor import CollectingDispatcher
#
#
# class ActionHelloWorld(Action):
#
#     def name(self) -> Text:
#         return "action_hello_world"
#
#     def run(self, dispatcher: CollectingDispatcher,
#             tracker: Tracker,
#             domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
#
#         dispatcher.utter_message("Hello World!")
#
#         return []
from typing import Dict, Text, Any, List, Union, Optional

from rasa_sdk import ActionExecutionRejection
from rasa_sdk import Action
from rasa_sdk import Tracker
from rasa_sdk.events import SlotSet
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.forms import FormAction, REQUESTED_SLOT
import requests

		
resource_topic_db={" nlp":[" nlp","language technlogy"]," ml":[" ml","machine learning","ai"],}
 
def resource_topic_validate(value:Text):
	for input in resource_topic_db:
		if value.lower() in resource_topic_db[input]:
			return input
	return None
 
class informForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "inform_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["inform_resource_type","inform_resource_topic"]
	def validate_inform_resource_type(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_resource_type', tracker)
			return {'inform_resource_type': None}
		return {'inform_resource_type': parseValue}
	def validate_inform_resource_topic(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = resource_topic_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_resource_topic', tracker)
			return {'inform_resource_topic': None}
		return {'inform_resource_topic': parseValue}
	
	def slot_mappings(self):
	
		return {
		"inform_resource_type": [self.from_entity(entity="inform_resource_type"),self.from_text()],
		"inform_resource_topic": [self.from_entity(entity="inform_resource_topic"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class informClean (Action):
	def name(self) -> Text:
		return "inform_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("inform_resource_type", None) ,SlotSet("inform_resource_topic", None) ]            
class ask_resourceForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "ask_resource_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["ask_resource_resource_type","ask_resource_resource_topic"]
	def validate_ask_resource_resource_type(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_resource_type', tracker)
			return {'ask_resource_resource_type': None}
		return {'ask_resource_resource_type': parseValue}
	def validate_ask_resource_resource_topic(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = resource_topic_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_resource_topic', tracker)
			return {'ask_resource_resource_topic': None}
		return {'ask_resource_resource_topic': parseValue}
	
	def slot_mappings(self):
	
		return {
		"ask_resource_resource_type": [self.from_entity(entity="ask_resource_resource_type"),self.from_text()],
		"ask_resource_resource_topic": [self.from_entity(entity="ask_resource_resource_topic"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class ask_resourceClean (Action):
	def name(self) -> Text:
		return "ask_resource_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("ask_resource_resource_type", None) ,SlotSet("ask_resource_resource_topic", None) ]            
class faq/ask_rasaForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "faq/ask_rasa_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["faq/ask_rasa_resource_topic"]
	def validate_faq/ask_rasa_resource_topic(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = resource_topic_validate(value)
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_resource_topic', tracker)
			return {'faq/ask_rasa_resource_topic': None}
		return {'faq/ask_rasa_resource_topic': parseValue}
	
	def slot_mappings(self):
	
		return {
		"faq/ask_rasa_resource_topic": [self.from_entity(entity="faq/ask_rasa_resource_topic"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class faq/ask_rasaClean (Action):
	def name(self) -> Text:
		return "faq/ask_rasa_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("faq/ask_rasa_resource_topic", None) ]            
	
	
	
	
class query_resource_empty (Action):
	def name(self) -> Text:
		return "action_query_resource_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
	
class ..._empty (Action):
	def name(self) -> Text:
		return "action_..._empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
class DefaultEmptyAction (Action):
	def name(self) -> Text:
		return "action_DefaultEmptyAction"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
