# This files contains your custom actions which can be used to run
# custom Python code.
#
# See this guide on how to implement these action:
# https://rasa.com/docs/rasa/core/actions/#custom-actions/


# This is a simple example for a custom action which utters "Hello World!"

# from typing import Any, Text, Dict, List
#
# from rasa_sdk import Action, Tracker
# from rasa_sdk.executor import CollectingDispatcher
#
#
# class ActionHelloWorld(Action):
#
#     def name(self) -> Text:
#         return "action_hello_world"
#
#     def run(self, dispatcher: CollectingDispatcher,
#             tracker: Tracker,
#             domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
#
#         dispatcher.utter_message("Hello World!")
#
#         return []
from typing import Dict, Text, Any, List, Union, Optional

from rasa_sdk import ActionExecutionRejection
from rasa_sdk import Action
from rasa_sdk import Tracker
from rasa_sdk.events import SlotSet
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.forms import FormAction, REQUESTED_SLOT
import requests

		
class request_restaurantForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "request_restaurant_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["request_restaurant_cuisine","request_restaurant_num_people","request_restaurant_outdoor_seating","request_restaurant_preferences","request_restaurant_feedback"]
	def validate_request_restaurant_cuisine(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_cuisine', tracker)
			return {'request_restaurant_cuisine': None}
		return {'request_restaurant_cuisine': parseValue}
	def validate_request_restaurant_num_people(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_num_people', tracker)
			return {'request_restaurant_num_people': None}
		return {'request_restaurant_num_people': parseValue}
	def validate_request_restaurant_outdoor_seating(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_outdoor_seating', tracker)
			return {'request_restaurant_outdoor_seating': None}
		return {'request_restaurant_outdoor_seating': parseValue}
	def validate_request_restaurant_preferences(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_preferences', tracker)
			return {'request_restaurant_preferences': None}
		return {'request_restaurant_preferences': parseValue}
	def validate_request_restaurant_feedback(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_feedback', tracker)
			return {'request_restaurant_feedback': None}
		return {'request_restaurant_feedback': parseValue}
	
	def slot_mappings(self):
	
		return {
		"request_restaurant_cuisine": [self.from_entity(entity="request_restaurant_cuisine"),self.from_text()],
		"request_restaurant_num_people": [self.from_entity(entity="request_restaurant_num_people"),self.from_text()],
		"request_restaurant_outdoor_seating": [self.from_entity(entity="request_restaurant_outdoor_seating"),self.from_text()],
		"request_restaurant_preferences": [self.from_entity(entity="request_restaurant_preferences"),self.from_text()],
		"request_restaurant_feedback": [self.from_entity(entity="request_restaurant_feedback"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class request_restaurantClean (Action):
	def name(self) -> Text:
		return "request_restaurant_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("request_restaurant_cuisine", None) ,SlotSet("request_restaurant_num_people", None) ,SlotSet("request_restaurant_outdoor_seating", None) ,SlotSet("request_restaurant_preferences", None) ,SlotSet("request_restaurant_feedback", None) ]            
class affirmForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "affirm_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["affirm_cuisine","affirm_num_people","affirm_outdoor_seating","affirm_preferences","affirm_feedback"]
	def validate_affirm_cuisine(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_cuisine', tracker)
			return {'affirm_cuisine': None}
		return {'affirm_cuisine': parseValue}
	def validate_affirm_num_people(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_num_people', tracker)
			return {'affirm_num_people': None}
		return {'affirm_num_people': parseValue}
	def validate_affirm_outdoor_seating(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_outdoor_seating', tracker)
			return {'affirm_outdoor_seating': None}
		return {'affirm_outdoor_seating': parseValue}
	def validate_affirm_preferences(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_preferences', tracker)
			return {'affirm_preferences': None}
		return {'affirm_preferences': parseValue}
	def validate_affirm_feedback(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_feedback', tracker)
			return {'affirm_feedback': None}
		return {'affirm_feedback': parseValue}
	
	def slot_mappings(self):
	
		return {
		"affirm_cuisine": [self.from_entity(entity="affirm_cuisine"),self.from_text()],
		"affirm_num_people": [self.from_entity(entity="affirm_num_people"),self.from_text()],
		"affirm_outdoor_seating": [self.from_entity(entity="affirm_outdoor_seating"),self.from_text()],
		"affirm_preferences": [self.from_entity(entity="affirm_preferences"),self.from_text()],
		"affirm_feedback": [self.from_entity(entity="affirm_feedback"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class affirmClean (Action):
	def name(self) -> Text:
		return "affirm_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("affirm_cuisine", None) ,SlotSet("affirm_num_people", None) ,SlotSet("affirm_outdoor_seating", None) ,SlotSet("affirm_preferences", None) ,SlotSet("affirm_feedback", None) ]            
class informForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "inform_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["inform_cuisine","inform_seating","inform_feedback"]
	def validate_inform_cuisine(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_cuisine', tracker)
			return {'inform_cuisine': None}
		return {'inform_cuisine': parseValue}
	def validate_inform_seating(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_seating', tracker)
			return {'inform_seating': None}
		return {'inform_seating': parseValue}
	def validate_inform_feedback(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_feedback', tracker)
			return {'inform_feedback': None}
		return {'inform_feedback': parseValue}
	
	def slot_mappings(self):
	
		return {
		"inform_cuisine": [self.from_entity(entity="inform_cuisine"),self.from_text()],
		"inform_seating": [self.from_entity(entity="inform_seating"),self.from_text()],
		"inform_feedback": [self.from_entity(entity="inform_feedback"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class informClean (Action):
	def name(self) -> Text:
		return "inform_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("inform_cuisine", None) ,SlotSet("inform_seating", None) ,SlotSet("inform_feedback", None) ]            
	
	
	
	
	
	
	
	
class validate_restaurant_form_empty (Action):
	def name(self) -> Text:
		return "action_validate_restaurant_form_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
	
	
	
	
	
	
	
class restaurant_form_empty (Action):
	def name(self) -> Text:
		return "action_restaurant_form_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
class DefaultEmptyAction (Action):
	def name(self) -> Text:
		return "action_DefaultEmptyAction"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
