# This files contains your custom actions which can be used to run
# custom Python code.
#
# See this guide on how to implement these action:
# https://rasa.com/docs/rasa/core/actions/#custom-actions/


# This is a simple example for a custom action which utters "Hello World!"

# from typing import Any, Text, Dict, List
#
# from rasa_sdk import Action, Tracker
# from rasa_sdk.executor import CollectingDispatcher
#
#
# class ActionHelloWorld(Action):
#
#     def name(self) -> Text:
#         return "action_hello_world"
#
#     def run(self, dispatcher: CollectingDispatcher,
#             tracker: Tracker,
#             domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
#
#         dispatcher.utter_message("Hello World!")
#
#         return []
from typing import Dict, Text, Any, List, Union, Optional

from rasa_sdk import ActionExecutionRejection
from rasa_sdk import Action
from rasa_sdk import Tracker
from rasa_sdk.events import SlotSet
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.forms import FormAction, REQUESTED_SLOT
import requests

		
class informarForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "informar_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["informar_nome","informar_idade"]
	def validate_informar_nome(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_nome', tracker)
			return {'informar_nome': None}
		return {'informar_nome': parseValue}
	def validate_informar_idade(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		try:
			parseValue = int (value)
		except ValueError:
			parseValue = None
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_idade', tracker)
			return {'informar_idade': None}
		return {'informar_idade': parseValue}
	
	def slot_mappings(self):
	
		return {
		"informar_nome": [self.from_entity(entity="informar_nome"),self.from_text()],
		"informar_idade": [self.from_entity(entity="informar_idade"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class informarClean (Action):
	def name(self) -> Text:
		return "informar_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("informar_nome", None) ,SlotSet("informar_idade", None) ]            
class menuForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "menu_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["menu_menu"]
	def validate_menu_menu(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_menu', tracker)
			return {'menu_menu': None}
		return {'menu_menu': parseValue}
	
	def slot_mappings(self):
	
		return {
		"menu_menu": [self.from_entity(entity="menu_menu"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class menuClean (Action):
	def name(self) -> Text:
		return "menu_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("menu_menu", None) ]            
class me_ajudaForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "me_ajuda_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["me_ajuda_meajuda"]
	def validate_me_ajuda_meajuda(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_meajuda', tracker)
			return {'me_ajuda_meajuda': None}
		return {'me_ajuda_meajuda': parseValue}
	
	def slot_mappings(self):
	
		return {
		"me_ajuda_meajuda": [self.from_entity(entity="me_ajuda_meajuda"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class me_ajudaClean (Action):
	def name(self) -> Text:
		return "me_ajuda_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("me_ajuda_meajuda", None) ]            
class exemplo_acaoForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "exemplo_acao_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["exemplo_acao_acao"]
	def validate_exemplo_acao_acao(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_acao', tracker)
			return {'exemplo_acao_acao': None}
		return {'exemplo_acao_acao': parseValue}
	
	def slot_mappings(self):
	
		return {
		"exemplo_acao_acao": [self.from_entity(entity="exemplo_acao_acao"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class exemplo_acaoClean (Action):
	def name(self) -> Text:
		return "exemplo_acao_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("exemplo_acao_acao", None) ]            
class exemplo_formsForm (FormAction):
	def name(self):
		# type: () -> Text
			"""Unique identifier of the form"""
			return "exemplo_forms_form"
				
	@staticmethod
	def required_slots(tracker: Tracker) -> List[Text]:
		"""A list of required slots that the form has to fill"""
		
		return ["exemplo_forms_forms","exemplo_forms_idade","exemplo_forms_nome"]
	def validate_exemplo_forms_forms(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_forms', tracker)
			return {'exemplo_forms_forms': None}
		return {'exemplo_forms_forms': parseValue}
	def validate_exemplo_forms_idade(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_idade', tracker)
			return {'exemplo_forms_idade': None}
		return {'exemplo_forms_idade': parseValue}
	def validate_exemplo_forms_nome(self, value: Text,dispatcher: CollectingDispatcher,tracker: Tracker,domain: Dict[Text, Any]) -> Dict[Text, Any]:
		parseValue = value
		if parseValue is None:
			dispatcher.utter_template('utter_wrong_nome', tracker)
			return {'exemplo_forms_nome': None}
		return {'exemplo_forms_nome': parseValue}
	
	def slot_mappings(self):
	
		return {
		"exemplo_forms_forms": [self.from_entity(entity="exemplo_forms_forms"),self.from_text()],
		"exemplo_forms_idade": [self.from_entity(entity="exemplo_forms_idade"),self.from_text()],
		"exemplo_forms_nome": [self.from_entity(entity="exemplo_forms_nome"),self.from_text()],}
	def submit(
		self,
		dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any],
		) -> List[Dict]:
		"""Define what the form has to do after all required slots are filled"""
		return []
	
class exemplo_formsClean (Action):
	def name(self) -> Text:
		return "exemplo_forms_clean"
	def run(self, dispatcher: CollectingDispatcher,
		tracker: Tracker,
		domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return [SlotSet("exemplo_forms_forms", None) ,SlotSet("exemplo_forms_idade", None) ,SlotSet("exemplo_forms_nome", None) ]            
	
	
class action_exemplo_empty (Action):
	def name(self) -> Text:
		return "action_exemplo_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
class action_default_fallback_empty (Action):
	def name(self) -> Text:
		return "action_default_fallback_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
class exemplo_forms_empty (Action):
	def name(self) -> Text:
		return "action_exemplo_forms_empty"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
class DefaultEmptyAction (Action):
	def name(self) -> Text:
		return "action_DefaultEmptyAction"
	
	def run(self, dispatcher: CollectingDispatcher,
			tracker: Tracker,
			domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		return []  
	
	
